<template>
  <div>

    <b-card
      no-body
      class="mb-0"
    >
      
      <b-form
        class="p-5"
        @submit.stop.prevent
      >
      <div class = "title">
        <h4>Registrar nuevo rol</h4>
      </div>
      <br>
        <b-alert variant="warning" :show="showAlert">Hay un campo vacio</b-alert>
        <b-alert variant="warning" :show="showAlertRequest">{{errorMessageRequest}}</b-alert>
          <b-form-group
            label="Nombre del rol"
            label-for="name"
            class="w-50"
          >
            <b-form-input
              id="name"
              
              v-model="formData.name"
              autofocus
              trim
              :state="validationName"
              maxlength="40"
              placeholder="Nombre del rol"
            />
            <b-form-invalid-feedback :state="validationName">
                Este campo es obligatorio
            </b-form-invalid-feedback>
                   

                  
          </b-form-group>
          
           <!-- PERMISSION TABLE -->
          <b-card
          no-body
          class="border mt-0 "
          style="max-width: 55rem;"

          >
          <b-card-header class="p-1">
            <b-card-title class="font-medium-2">
              <feather-icon
                icon="LockIcon"
                size="18"
              />
              <span class="align-middle ml-50">Permisos</span>
            </b-card-title>
          </b-card-header>
            <b-card-text>
              <b-col >
                <permissions-table :permissions="formData.permissions"   ></permissions-table>
              </b-col>
            </b-card-text>
          </b-card>
          <div class="d-flex mt-2">
            <b-button

              variant="primary"
              class="mr-2"
              type="submit"
              :disabled="lockedSubmitByName"
              @click="handleSubmit()"
            >
              Agregar
            </b-button>
            <b-button
  
              type="button"
              @click="$router.back()"
              variant="outline-secondary"
           
            >
              Cancelar
            </b-button>
          </div>
      </b-form>
    </b-card>
    


  </div>
</template>

<script>
import {
  BSidebar, BForm, BFormGroup,BCol, BFormInput, BFormInvalidFeedback, BButton,BTab,BCardText, 
  BTabs, BCard, BCardHeader, BCardTitle,BAlert, BLink,BTable,BFormCheckbox
} from 'bootstrap-vue'
import PermissionsTable from '../PermissionsTables.vue'
export default {
  components: {
    BTab,
    BTabs,
    BCard,
    BAlert,
    BLink,
    BSidebar,
    BForm,
    BFormGroup,
    BFormInput,
    BFormInvalidFeedback,
    BButton,
    BTable,
    BFormCheckbox,
    BCardHeader,
    BCardTitle,
    PermissionsTable,
    BCardText,
    BCol,

    
 
  },

  data(){
    return{
      formData:{
        name:'',
        permissions:[{permissionId:'1',selected:false},{permissionId:'2',selected:false},{permissionId:'3',selected:false},
          {permissionId:'4',selected:false},{permissionId:'5',selected:false},{permissionId:'6',selected:false},
          {permissionId:'7',selected:false},{permissionId:'8',selected:false},{permissionId:'9',selected:false},
          {permissionId:'10',selected:false},{permissionId:'11',selected:false},{permissionId:'12',selected:false},
          {permissionId:'13',selected:false},{permissionId:'14',selected:false},{permissionId:'15',selected:false},
          {permissionId:'16',selected:false},{permissionId:'17',selected:false},{permissionId:'18',selected:false},
          {permissionId:'19',selected:false},{permissionId:'20',selected:false},{permissionId:'21',selected:false},
          {permissionId:'22',selected:false},{permissionId:'23',selected:false},{permissionId:'24',selected:false},
          {permissionId:'25',selected:false},{permissionId:'26',selected:false},{permissionId:'27',selected:false},
          {permissionId:'28',selected:false},{permissionId:'29',selected:false},{permissionId:'30',selected:false},
          {permissionId:'31',selected:false},
        ]

      },
   
      showAlert:false,
      showAlertRequest:false,
      hasWrittenName:false,
      hasWrittenRfc:false,
      errorMessageRequest:'',
      lockedSubmitByName:true,

    }
  },
  methods:{
    handleSubmit(){
      if(this.formData.name===''){
          this.showAlert=true
          return
      }else{
      
        this.$http.post('roles/create',this.formData).then(res =>{
            this.$router.push({ name: 'apps-roles-list' })

        }).catch(err=>{
          if (err.response.status == 422){
            console.log('err')
            
           
          }
        })
      }
            
    },
  },
  computed: {
      validationName() {
        if (this.formData.name.length > 0){
          this.hasWrittenName = true
        } 
        if(this.hasWrittenName && this.formData.name.length > 0 ){
          this.lockedSubmitByName = false
          return true
        }else if(this.hasWrittenName){
          this.lockedSubmitByName = true
          return false
        }
      },
    
      
     
    },



}
</script>

<style>

</style>
